SystemOrganization addCategory: #'Websela-Model'!
SystemOrganization addCategory: #Websela!

SMSqueakMap subclass: #WSModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Websela'!

HVTransientView subclass: #WSBaseView
	instanceVariableNames: 'formatter html'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Websela'!

!WSBaseView commentStamp: '<historical>' prior: 0!
A base view class mostly used for utility methods.!

!WSBaseView class methodsFor: 'as yet unclassified' stamp: 'chc 4/2/2013 16:38'!
autoVersionAtEnd: aString
	"If <aString> ends with an autoversion it is returned:
		self autoVersionAtEnd: 'Blabla 1.2' -> '1.2'	
		self autoVersionAtEnd: 'Blabla1.2'   -> nil
		self autoVersionAtEnd: 'Blabla 1.a2' -> nil
	"
	| s c |
	s _ aString size.
	s to: 1 by: -1 do: [:i |
		c _ aString at: i.
		(c = Character space) ifTrue: [
			i = s ifTrue: [^nil] ifFalse: [^aString copyFrom: i+1 to: s]].
		(c isDigit or: [c = $.]) ifFalse: [^nil]]! !

!WSBaseView class methodsFor: 'as yet unclassified' stamp: 'chc 4/9/2013 15:32'!
createModel
	^SMSqueakMap default! !

!WSBaseView class methodsFor: 'as yet unclassified' stamp: 'chc 4/2/2013 16:38'!
squeakMapServer
	^'http://marvin.bluefish.se:8000'! !

!WSBaseView methodsFor: 'private' stamp: 'chc 4/2/2013 16:38'!
accountLink: anAccount
	"Return a link to given account."

	^self topView linklocal: '/accountbyid/', anAccount id asString text: anAccount nameWithInitials! !

!WSBaseView methodsFor: 'private' stamp: 'chc 4/2/2013 16:38'!
before: obj in: coll
	"Return the object before <obj> in <coll>. I noone is found
	(obj is first or not in coll) return nil."

	coll first = obj ifTrue:[^nil].
	^coll before: obj ifAbsent: [nil]! !

!WSBaseView methodsFor: 'views' stamp: 'chc 4/2/2013 16:38'!
categoryViewOn: aCat
	"Wrap the category in a view."

	^SMCategoryView on: aCat parent: self! !

!WSBaseView methodsFor: 'links' stamp: 'chc 4/2/2013 16:38'!
coPackageLink: aPackage

	^self linklocal: '/copackage/', aPackage id asString text: aPackage name! !

!WSBaseView methodsFor: 'links' stamp: 'chc 4/2/2013 16:38'!
editCoPackageLink: aPackage

	^self linklocal: '/copackage/', aPackage id asString, '/edit' text: 'edit'! !

!WSBaseView methodsFor: 'links' stamp: 'chc 4/2/2013 16:38'!
editCoPackageReleasesLink: aPackage

	^self linklocal: '/copackage/', aPackage id asString, '/editreleases' text: 'edit releases'! !

!WSBaseView methodsFor: 'private' stamp: 'chc 4/2/2013 16:38'!
editOrPassword: builder
	"Factored out."

	builder br; linkLocal: '/edit' text: 'Edit registration'; html: ' (requires password) or '.
	builder linkLocal: '/mailpassword' text: 'mail a new password to the registrant'; html: ' because he has forgotten it.'; br.! !

!WSBaseView methodsFor: 'links' stamp: 'chc 4/2/2013 16:38'!
editPackageLink: aPackage

	^self linklocal: '/package/', aPackage id asString, '/edit' text: 'edit'! !

!WSBaseView methodsFor: 'links' stamp: 'chc 4/2/2013 16:38'!
editPackageReleasesLink: aPackage

	^self linklocal: '/package/', aPackage id asString, '/editreleases' text: 'edit releases'! !

!WSBaseView methodsFor: 'private' stamp: 'chc 4/2/2013 16:38'!
fileLink: aFileName
	"Return a link to given filename in the current logged in account."

	^self link: (self fileUrl: aFileName) text: aFileName! !

!WSBaseView methodsFor: 'private' stamp: 'chc 4/2/2013 16:38'!
fileUrl: aFileName
	"Return an absolute URL to given filename in the current logged in account."

	| account |
	account _ self currentAccount.
	^SMUtilities masterServer, '/accountbyid/',  account id asString, '/files/', aFileName! !

!WSBaseView methodsFor: 'private' stamp: 'chc 4/2/2013 16:38'!
format: aString
	"Format the string according to swikification."

	^self formatter swikify: aString! !

!WSBaseView methodsFor: 'private' stamp: 'chc 4/2/2013 16:38'!
formatter
	"Returns a swiki formatter."

	| topView |
	formatter ifNotNil: [^formatter].
	topView _ self topView.
	formatter _ SMHtmlFormatter base: topView baseUrl model: topView.
	^formatter! !

!WSBaseView methodsFor: 'as yet unclassified' stamp: 'chc 4/3/2013 16:26'!
header
	c div class: 'navbar navbar-inverse navbar-fixed-top'; with: [ 
      c div class: 'navbar-inner'; with: [ 
      c div class: 'container-fluid'; with: [
      c button class: 'btn btn-navbar'; "dataToggle: 'collapse'; dataTarget: '.nav-collapse';" with: [
      c span class: 'icon-bar'.
      c span class: 'icon-bar'.
	c span class: 'icon-bar' ].
	c a class: 'brand'; url: '/'; with: 'Websela'.
      c div class: 'nav-collapse collapse'; with: [
      c unorderedList class: 'nav'; with: [
 	c li: [ c a url: 'accounts'; with: 'Accounts'].
      c li: [ c a url: 'categories';  with: 'Categories'].
      c li: [  c a url: 'packages';  with: 'Packages' ].

           					]. 
    												  ]. 
											]. 
										]. 
																	].! !

!WSBaseView methodsFor: 'private' stamp: 'chc 4/2/2013 16:38'!
linkEntered: url text: label
	"Returns a default empty value for presentation."

	^(url isNil or: [url isEmpty]) ifTrue:['<i>&lt;Not entered&gt;</i>'] ifFalse: [self link: url text: label]! !

!WSBaseView methodsFor: 'as yet unclassified' stamp: 'chc 4/2/2013 16:38'!
linksbar

	"c div id: 'nav'; with: [
		c unorderedList: [
			c listItem: [ c anchor id: 'accountsWithName'; url: 'accounts'; with: 'Accounts'].	
    			c listItem: [ c anchor url: 'categories'; with: 'Categories'].
     			c listItem: [ c anchor url: 'packagesbyname'; with: 'Packages'].
  			c listItem: [ c anchor url: 'register'; with: 'Register'].
 			c listItem: [ c anchor url: 'account'; with: 'Login'].
    						]
						]
  "! !

!WSBaseView methodsFor: 'email' stamp: 'chc 4/2/2013 16:38'!
mailpassword
	"Offer to mail a new random password to the user because it has been forgotten."

	| b msg |
	b _ self builder.
	b h1: 'Mail extra random password'.
	b postForm.
	msg _ b var.
	msg value: 'Would you like a new extra random password for the account held by <b>', model name, '</b>?<br />', 'It will be sent to ', (self personLink: model email), '.'.
	b br; br; submit: 'Send extra random password by email'; endForm.
	b ifPost: [
		[model mailRandomPasswordToRegistratorWithLink: (self linkBase: SMBaseView squeakMapServer local: '/login' text: 'to login').
		parent model logUpdate: model "since the password has been changed we need to log".
		msg value: 'Email has been sent.']
			ifError: [msg value: 'Something went wrong when mailing the new random password to ', (self personLink: model email), '.<br />Contact SqueakMap administrator.'].
		].
	b hr; linkBackParent: 'Back'; end.
	^b! !

!WSBaseView methodsFor: 'private' stamp: 'chc 4/2/2013 16:38'!
mailto: email name: aName
	"Produces:
		'<a href='mailto:rob@here.com'>Robert Robertson</a>'
	"

	^self link: 'mailto:', email text: aName! !

!WSBaseView methodsFor: 'private' stamp: 'chc 4/2/2013 16:38'!
modulePathFor: aCard
	"Show the module path or a text indicating no module path available."

	^aCard modulePath isEmpty ifTrue: ['<i>not a module</i>'] ifFalse: [aCard modulePath]! !

!WSBaseView methodsFor: 'private' stamp: 'chc 4/2/2013 16:38'!
nonEntered
	"Returns a default empty value for presentation."

	^'<i>&lt;Not entered&gt;</i>'! !

!WSBaseView methodsFor: 'private' stamp: 'chc 4/2/2013 16:38'!
nonEntered: aString
	"Returns a default empty value for presentation."

	^(aString isNil or: [aString isEmpty]) ifTrue:['<i>&lt;Not entered&gt;</i>'] ifFalse: [aString]! !

!WSBaseView methodsFor: 'private' stamp: 'chc 4/2/2013 16:38'!
none
	"Returns a default empty value for presentation."

	^'<i>&lt;None&gt;</i>'! !

!WSBaseView methodsFor: 'views' stamp: 'chc 4/2/2013 16:38'!
packageReleaseViewOn: aPackageRelease
	"Wrap the package release in a view."

	^SMPackageReleaseView on: aPackageRelease parent: self! !

!WSBaseView methodsFor: 'views' stamp: 'chc 4/2/2013 16:38'!
packageViewOn: aPackage
	"Wrap the package in a view."

	^SMPackageView on: aPackage parent: self! !

!WSBaseView methodsFor: 'private' stamp: 'chc 4/2/2013 16:38'!
personLink: aString
	"Converts <aString> to an HTML mailto: link as this:
		'Robert Robertson <rob@here.com>' ->
		'<a href='mailto:rob@here.com'>Robert Robertson</a>'
	If <aString> does not conform it will be returned unchanged."

	| lessThan moreThan |
	lessThan _ aString indexOf: $<.
	moreThan _ aString indexOf: $>.
	(lessThan * moreThan = 0) ifTrue:[^aString].
	^self link: 'mailto:', (aString copyFrom: lessThan + 1 to: moreThan - 1) text: (aString copyFrom: 1 to: lessThan - 2)! !

!WSBaseView methodsFor: 'as yet unclassified' stamp: 'chc 4/4/2013 15:58'!
title

	^'Websela'! !

!WSBaseView methodsFor: 'private' stamp: 'chc 4/2/2013 16:38'!
urlAndString: aBlock forLink: aString
	"Resolve aString into a relative url. Case insensitive.
	We check for developer initials, account names case insensitive,
	package names (case insensitive, beginning), package releases
	(if an autoversion is tacked on), resource names and category
	names in that order. If nothing matches the string is returned as it is."

	| hit string map autoVersion release |
	map _ self topView model.
	string _ aString asLowercase.

	"This one is exact since the developer initials are unique including case."
	hit _ map accountForUsername: aString.
	hit ifNotNil: [^aBlock value: 'accountbyid/', hit id asString value: hit name ].

	"This one is case insensitive but exact otherwise"
	hit _ map accounts detect: [:a | a name asLowercase = string] ifNone: [nil].
	hit ifNotNil: [^aBlock value: 'accountbyid/', hit id asString value: aString].

	"Next is packages. First we check if the search string ends with a space
	followed by an automaticVersion and then we try
	to find that specific release. If no automaticVersion is found we link to package."
	autoVersion _ self class autoVersionAtEnd: string.
	autoVersion ifNotNil: [string _ string copyFrom: 1 to: string size - autoVersion size].
	"This is one is fuzzy... removes whitespace and is case insensitive. Also matches beginning."
	hit _ map packageWithNameBeginning: string.
	hit ifNotNil: [
		autoVersion ifNil: [^aBlock value: 'package/', hit id asString value: hit name]
			ifNotNil: [
				release _ hit releaseWithAutomaticVersionString: autoVersion.
				release
					ifNil: [^aBlock value: 'package/', hit id asString value: hit name]
					ifNotNil: [^aBlock value: 'package/', hit id asString, '/autoversion/',
						release automaticVersion versionString value: release packageNameWithVersion]]].
	"resource names here"

	hit _ map categoryWithNameBeginning: string.
	hit ifNotNil: [^aBlock value: 'category/', hit id asString value: hit name].

	^aBlock value: aString value: aString
! !

!WSBaseView methodsFor: 'private' stamp: 'chc 4/2/2013 16:38'!
validateEmail: aString
	"Validate that <aString> conforms to at least this syntax:
		'something @ something . something'
	"

	| s at dot |
	s _ aString withBlanksTrimmed.
	at _ aString indexOf: $@.
	dot _ s indexOf: $. startingAt: at.
	((dot * at) = 0) ifTrue:[^false].
	(at > 1) & (at < dot) & (dot < s size) ifFalse:[^false].
	^true! !

!WSBaseView methodsFor: 'private' stamp: 'chc 4/2/2013 16:38'!
validatePersonLink: aString
	"Validate that <aString> conforms to at least this syntax:
		'something < something @ something >'
	This implementation is twice as fast as:
		^'*<*@*>' match: aString withBlanksTrimmed
	...and verifies that <something> is not the empty String."

	| lessThan moreThan s at |
	s _ aString withBlanksTrimmed.
	lessThan _ s indexOf: $<.
	moreThan _ s indexOf: $>.
	at _ aString indexOf: $@.
	((lessThan * moreThan * at) = 0) ifTrue:[^false].
	(lessThan > 1) & (moreThan = s size) & (lessThan < at) & (at < moreThan) ifFalse:[^false].
	^true! !

WSBaseView subclass: #WSHome
	instanceVariableNames: 'account uuid randomPass port link error message username'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Websela'!

!WSHome commentStamp: '<historical>' prior: 0!
Explore -- SMSqueakMap default -- in a Workspace and you get an empty object. Go to the Squeak Map GUI and press Update and then explore again and  you see all the objects in Squeak Map. (These objects will be coming from a file you downloaded from the internet to a folder called sm.) SMView is an application using WebClient as its server to present this information online. 
	
SMSqueakMap is in every Squeak image. It is a model for the data that is collected by Squeak Map. It has basically has three kinds of objects: category; package; and, account. Each instance of these objects is uniquely identified with a UUID. Each account object lists the packages of that an member is responsible for. The package object is a general container for actual releases. Releases do not have a UUID. They are contained in an OrderedCollection in the package object. The release objects contain the only piece of information that really matters -- the url of where a person can get the source code for that release. (The url can deliver any kind of source code unit such as .cs, .mcz, .sar, etc. It is this inclusiveness of file format that makes Squeak Map flexible. The source code is stored all over the web.) 

SMView ( a rewrite of Goran Krampe's SMServer ) is ultimately about providing those urls that furnish source code. But that is not what SMView spends most of its time doing. Each of the three kinds of objects related to an member (account, package, and release) need to be configured by the member as desired, when desired. That means that each of those objects needs to be presented online in a form in a browser with the existing settings. Then the settings can be changed and saved. The account, package, and release objects can be created or deleted. (Only sysadmins of Squeak Map can create or delete categories.) 

There are two areas to Squeak Map -- public and authenticated. The aim of Squeak Map is to disseminate code to all who want it. The public areas do that. The authenticated area is for an individual member to change settings. Public urls will look like this: 

/accounts
/categories
/packagesbyname
/accountbyid/anUUID
/category/anUUID
/package/anUUID
/package/anUUID/autoversion/foo

(Side note: Little effort was put into hopping around the urls. Press back on your browser to go back. To reset a form press refresh on your browser. To return home click on the banner logo.)

The authenticated areas have urls that look like this:

/account
/account/package/anUUID
/account/package/anUUID/releaseSettings/foo

The point of this is to demonstrate how a UUID is in the url and that sometimes selectors come after the UUID. From the point of view of this programmer, learning how to reach selectors after the UUID was the challenge in understanding how to build a new Squeak Map server. Take #autoversion as an example:

#autoversion
	| release v |
	v := self nextMethod. "the UUID in the url"
	release := model releaseWithAutomaticVersionString: v.
	^(release viewFor: self) default
	
This method gets the next token on the url, aUUID, asks the model for an object, which is then wrapped with a view object here in the server code, and then it's sent the selector #default. The result is a web page that goes over the wire. The view will ask the model for an object, get one, wrap it, and then send it. But because the releases don't have their own UUID, the process of finding them and rendering them is different than for category, account, or package objects. That was elusive. I think it's known as double dispatch.

Everything else about this is well documented elsewhere. The WACanvas comes from Seaside. The dispatching mechanism from HTTPView2. The server is WebClient.!

!WSHome methodsFor: 'urls' stamp: 'chc 4/2/2013 16:37'!
account

	| server accountWithState |
	server := WebServer default.
	accountWithState := server sessionAt: (request cookieAt: 'session').
	accountWithState isNil 
	"test if there is a cookie. If not, then go to login"
		ifTrue: [ ^self login asWebResponseTo: request ]
	"since a cookie is discovered, we get the account object, wrap it, and deliver it"
		ifFalse: [^(accountWithState viewFor: self) dispatchOn: self nextMethod]
						
	
! !

!WSHome methodsFor: 'view on' stamp: 'chc 4/2/2013 16:37'!
accountViewOn: anAccount

	^SMAccountView on: anAccount parent: self! !

!WSHome methodsFor: 'urls' stamp: 'chc 4/2/2013 16:37'!
accountbyid
	
	"Request for a specific account. Pick out the UUID, look it up
	and delegate to a view."

	| uuid method |
	
	uuid _ self nextMethod.
	account _ model accountWithId: uuid.
	method := self nextMethod.
	^(account publicViewFor: self) dispatchOn: method.
	
	! !

!WSHome methodsFor: 'urls' stamp: 'chc 4/2/2013 16:37'!
accounts

	c _ self canvas.
	c buildHead.
		self header.
		c div id: 'main'; with: [ 
	c heading: 'Accounts'.
	c unorderedList: [ model accountsByName do: [: ea | c listItem: [ c anchor url: '/accountbyid/' , ea id ; with: ea name. 	c text: ' - ' ,  ea summary]]].
	
		].

	^c! !

!WSHome methodsFor: 'urls' stamp: 'chc 4/2/2013 16:37'!
accountswithname

		| uuid account method |

	uuid _ self nextMethod.
	account _ model accountWithName: uuid.
	method := self nextMethod.
	^(account viewFor: self) dispatchOn: method


! !

!WSHome methodsFor: 'urls' stamp: 'chc 4/2/2013 16:37'!
categories
	"Browse top categories."

	
	c _ self canvas.
	c buildHead.
		self header.
	c div id: 'main'; with: [ 
	c heading: 'Categories'.
	c unorderedList: [ model topCategories do: [:ea | c listItem: [ c anchor url: 'category/' , ea id; with: ea name. c text: ' - ' , ea summary ]]].

					].
	^c! !

!WSHome methodsFor: 'urls' stamp: 'chc 4/2/2013 16:37'!
category

	| uuid cat |
	uuid _ self nextMethod.
	cat _ [model categoryWithId: uuid] ifError: [nil].
	cat ifNil: [^self serverError: 'No category found with id ', uuid].
	^(cat viewFor: self) dispatch! !

!WSHome methodsFor: 'view on' stamp: 'chc 4/2/2013 16:37'!
categoryViewOn: aCategory
	
	^SMCategoryView on: aCategory parent: self! !

!WSHome methodsFor: 'urls' stamp: 'chc 4/15/2013 15:28'!
default
	html := self canvas.
	html buildHead.
	html div class: 'navbar navbar-inverse navbar-fixed-top'; with: [ 
			
      html div class: 'navbar-inner'; with: [ 
      html div class: 'container-fluid'; with: [
      html button class: 'btn btn-navbar'; with: [
      html span class: 'icon-bar'.
      html span class: 'icon-bar'.
	html span class: 'icon-bar' ].
	html a class: 'brand'; url: '/'; with: 'Websela'.
     " html unorderedList class: 'nav'; with: [
 	html li: [ html a url: 'accounts'; with: 'Accounts'].
      html li: [ html a url: 'categories';  with: 'Categories'].
      html li: [  html a url: 'packages';  with: 'Packages' ]]"]].
	html div class: 'container-fluid'; with: [										
	html div class: 'row-fluid'; with: [  
	html div class: 'span4'; id: 'bob'; with: [ 
	html heading: 'Make A Website With Smalltalk ' level: 3.
	html paragraph: '1 - Register.'.
	html div id: 'submit'; with: [
						html form: [ html textInput name: '1'; value: 'email'. html br. 
						html textInput name: '2'; value: 'username'. html br.
						html submitButton ]].
	html paragraph: '2 - See your site at httparagraph://username.websela.com:'.
	link ifNotNil: [ html a url: link; target: 'blank'; with: link].
	html paragraph: '3 - Download development image.'.
	html a url: 'http://www.osrcon.ca/downloadimage.zip'; with: 'Download'.
	html paragraph: '4 - Start image and change Hello World to another phrase.'.
	html paragraph: '5 - With emailed password, use Monticello to send your code change to http://username.websela.com.'. 
	html paragraph: '6 - Wait a minute while the code loads. Refresh your browser to see the change.'.].
	html paragraph: error. 
	"self accountCompleted" 
	]]].
	^html	

! !

!WSHome methodsFor: 'view on' stamp: 'chc 4/2/2013 16:37'!
loadgz
	"The user requests a compressed snapshot of the current full map.
	To begin with we use an ImageSegment in SM2."

	"((req getFields at: #mapversion
		ifAbsent: [^self compress: 'No mapversion specified'])
			= SMSqueakMap version)
		ifTrue:[
			(((req getFields at: #checkpoint ifAbsent: [^self compress: 'No checkpoint specified!!'])
				asNumber < model checkpointNumber) or: [model isDirty])
					ifTrue: [^model getLastCheckpointWithFilename]
					ifFalse: [^'UPTODATE']]
		ifFalse:[^'Server version:', SMSqueakMap version]"! !

!WSHome methodsFor: 'view on' stamp: 'chc 4/2/2013 16:37'!
login

	"This form is for the login form and collects the initials and password to take them to their account"
	c := self canvas.
	c buildHead.
		self header.
		self linksbar.
	c div id: 'main'; with: [ 
			  c heading: 'Login'.
	c form: [ c text: 'Username: '. c textInput name: '1'. c break. 
			  c text: 'Email: '. c textInput name: '2'. c break.
			  c submitButton value: 'Login']].
	^c 
	

	"c text: 'Initials: '. c textInput name: '1'. c break. 
			  c text: 'Password: '. c textInput name: '2'. c break.
			  c submitButton value: 'Login']"! !

!WSHome methodsFor: 'urls' stamp: 'chc 4/2/2013 16:37'!
package

	| uuid package method |

	uuid _ self nextMethod.
	package _ model packageWithId: uuid.
	method := self nextMethod.
	^(package viewFor: self) dispatchOn: method


! !

!WSHome methodsFor: 'view on' stamp: 'chc 4/2/2013 16:37'!
packageReleaseViewOn: aPackage

	^SMPackageReleaseView on: aPackage parent: self! !

!WSHome methodsFor: 'view on' stamp: 'chc 4/2/2013 16:37'!
packageViewOn: aPackage

	^SMPackageView on: aPackage parent: self! !

!WSHome methodsFor: 'urls' stamp: 'chc 4/2/2013 16:37'!
packagesbyname
	
	c _ self canvas.
	c buildHead.
		self header.
		c div id: 'main'; with: [ 
	c heading: 'Packages'.
	c unorderedList: [ model packagesByName do: [: ea | c listItem: [ c anchor url: 'package/' , ea id ; with: ea name. 	c text: ' - ' ,  ea summary]]].
	
		].

	^c! !

!WSHome methodsFor: 'processform' stamp: 'chc 4/15/2013 15:26'!
processForm
	| account email messageText |
				"get data from from"
	name := html nameField: '1'.
	email := html nameField: '2'.
			[	"if this account already exists do nothing they can go to their control panel"
	(model accountForName: name) ifNotNil: [	
				"validate form data"
	(self validateUltraSafeString: name) ifFalse: [ messageText := 'This username doesn''t work..' ].
	(model emailOccupied: email) ifTrue: [ messageText := 'This email is taken'].
	(self validateEmail: email) ifFalse: [ messageText :=  'This email is not valid']. 
				"create new account"
	port := ((6380 to: 9999) atRandom) asString.
	account := model newAccount: name username: nil email: email.
	randomPass := account createRandomPassword.
	model addObject: account.
				"write to the directory farm and email"
	self writeSubdomainsFile.
	self writeUserDirectories.
	self writeFileInDirectory.
				" send email and populate link var with an address for homepage"
	SMUtilities mailPassword: randomPass forNew: account..
	link := ('http://' , name , '.websela.com').
											]]  on: Exception do: [:ex | error := ex messageText ].
	message := 'The account has been created. A confirmaiton email has been sent to ' , email 							
	! !

!WSHome methodsFor: 'processform' stamp: 'chc 5/18/2013 12:49'!
processFormNextVersion
	| email messageText passwd |
				"get data from from"
	username := html nameField: '1'.
	email := html nameField: '2'.
			[	
				"validate form data with HVTransientView methods"
	(self validateUltraSafeString: username) ifFalse: [ messageText := 'This username doesn''t work..' ].  
	(self validateEmail: email) ifFalse: [ messageText :=  'This email is not valid']. 	
	
	"if this account already exists do nothing they can go to their control panel"
	(self accountForName: username) ifNotNil: [	"change this to checking Redis"
	
				"generate username and password"
	port := ((6380 to: 9999) atRandom) asString.
	passwd := SMAccount new createRandomPassword.
	
				"write new into Redis"
	"need to concatenate the password, port, and email with a colon behind the username (i.e. redcar:email)"
	"and then user #set:value: to put the key and value (ie. redcar:email vanya@gmail.com) into Redis."
	
				" send email and populate link var with an address for homepage"
	self mailPassword: passwd for: email.
	link := ('http://' , username , '.websela.com').
											]]  on: Exception do: [:ex | error := ex messageText ].
	message := 'The account has been created. A confirmaiton email has been sent to ' , email 							
	! !

!WSHome methodsFor: 'urls' stamp: 'chc 4/2/2013 16:37'!
publicAccountViewOn: anAccount

	^SMPublicAccountView on: anAccount parent: self! !

!WSHome methodsFor: 'urls' stamp: 'chc 4/2/2013 16:37'!
register

	c := self canvas.
	c buildHead.
		self header.
		self linksbar.
	c div id: 'main'; with: [
		c paragraph: 'Not open at the moment' 
						].
	^c 	
	
	
	
	
	"^(SMRegisterForm on: model parent: self) register"

	! !

!WSHome methodsFor: 'processform' stamp: 'chc 4/10/2013 16:35'!
writeFileInDirectory
	| stream |
	stream := FileStream forceNewFileNamed: '/Users/chriscunnington/Desktop/homepageimage/' , port ,  '/startparams.st'.
	stream 
			nextPutAll: '(MCWebServer reset default) addUser: ''';
	 		nextPutAll:  name;
			nextPutAll: ''' withPassword: ''';
			nextPutAll: randomPass;
			nextPutAll: '''; listenOn:';
			nextPutAll: port.
	stream close. 

! !

!WSHome methodsFor: 'processform' stamp: 'chc 4/10/2013 16:35'!
writeSubdomainsFile
	| astr |
	astr := FileStream oldFileNamed: '/Users/chriscunnington/Desktop/homepageimage/subdomains'.
	astr position: astr size. 
	astr nextPutAll: name; tab; nextPutAll: port; cr.  
! !

!WSHome methodsFor: 'processform' stamp: 'chc 4/4/2013 16:03'!
writeUserDirectories
	FileDirectory new createDirectory: '/Users/chriscunnington/Desktop/homepageimage/' , port! !

SMAccount subclass: #WSAccount
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Websela'!
